<meta charset="utf-8">
<head>
    <script src="https://d3js.org/d3.v7.min.js"></script>
</head>

<body>
<!--    <h1>Test SVG image timeline and zooming on SVG element</h1>-->
    <form>
        <button name="in" type="button" onclick="ld.zoomIn()">Zoom In</button>
        <button name="out" type="button" onclick="ld.zoomOut()">Zoom Out</button>
    </form>
    <div class="viewer-container" id="viewer-container"></div>
</body>

<script>
url = '/static/json/newlayout.json';
ld = loadPlotLayout(url);
ld.loadJson();
console.log(ld);

function loadPlotLayout(url) {

    layoutdata = {}

    layoutdata.get_layoutdata = function() {
        return layoutdata;
    }

    layoutdata.loadJson = function() {
        fetch(url)
            .then(function(resp) { return resp.json() })
            .then(function(layoutdatajson) {
                layoutdata = layoutdatajson;
                // Compute some additional layout geometry info
                processLayout(layoutdata);
                // Create the axes & backgrounds
                setupLayout(layoutdata);

                // Reorganize which data to download
                data_store_products = processDataProducts(layoutdata);
                // Download the data
                data_store_products = loadDataProducts(layoutdata, data_store_products);

                // Plot the data
                // plotData(layoutdata, data_store_products);

                // Set up the zooming behaviour
                setupZoom(layoutdata);
            });
        return layoutdata;
    }

    function processLayout(layoutdata) {
        cumulative_graph_height = 0

        layoutdata.rows.forEach(function(row, i) {
            layoutdata.rows[i]['top_offset'] = layoutdata.margins['global_margin_top']
              + (i+1) * layoutdata.margins['row_margin_top']
              + i * layoutdata.margins['row_margin_bottom']
              + cumulative_graph_height
            cumulative_graph_height += row.height;

        });
    }

    function setupLayout(layoutdata) {
        width = layoutdata['dimensions']['width']
        height = layoutdata['dimensions']['height']
        container_div = d3.select(".viewer-container")
            .attr("style", "border: 2px");

        layoutdata['mainsvg'] = container_div
            .append('svg')
            .attr("width", width)
            .attr("height", height);

        // Prepare shared x-axis object
        x_domain = [new Date("2021-12-01T00:00:00Z"), new Date("2021-12-25T00:00:00Z")]
        x_range = [layoutdata['margins']['global_margin_left'],
                 width - layoutdata['margins']['global_margin_right']]
        layoutdata['xscale'] = d3.scaleTime().domain(x_domain).range(x_range);
        xAxis = d3.axisBottom(layoutdata['xscale']);

        // Set up groups and axes for each row
        layoutdata.rows.forEach(function(row, i) {
            layoutdata.rows[i]['rowsvg'] = layoutdata['mainsvg'].append("svg")
                .attr("id", row['subplotid'])
                .attr("width", width)
                .attr("height", row.height + layoutdata.margins['row_margin_top'] + layoutdata.margins['row_margin_bottom'])
                .attr("x", 0)
                .attr("y", row['top_offset']);

            // Draw X-axis
            layoutdata.rows[i]['xaxis_group'] = layoutdata.rows[i]['rowsvg'].append("g")
                .attr("transform", "translate(0, " +  (row.height + layoutdata.margins['row_margin_top']) + ")")
                .call(xAxis);

            // Prepare Y-axis object
            y_domain = [row['ymin'], row['ymax']]
            y_range = [layoutdata.rows[i]['height'], 0]
            layoutdata.rows[i]['yscale'] = d3.scaleLinear()
                .domain(y_domain)
                .range(y_range);
            layoutdata.rows[i]['yAxis'] = d3.axisLeft(layoutdata.rows[i]['yscale']);

            // Draw Y-axis
            layoutdata.rows[i]['yaxis_group'] = layoutdata.rows[i]['rowsvg'].append("g")
                .attr("transform", "translate(" + layoutdata.margins['global_margin_left'] + "," + layoutdata.margins['row_margin_top'] + ")")
                .call(layoutdata.rows[i]['yAxis']);

            // Draw a rectangle, to set background colour
            layoutdata.rows[i]['rowsvg'].append('rect')
                .attr('x', layoutdata.margins['global_margin_left'])
                .attr('y', layoutdata.margins['row_margin_top'])
                .attr('width', width - layoutdata.margins['global_margin_left'] - layoutdata.margins['global_margin_right'])
                .attr('height', row.height)
                .attr('fill', '#f5f5f5')
                .attr('stroke', 'none');

            // Set up groups for plot elements, group order represents Z-order of plotting
            layoutdata.rows[i]['plot_elements'].forEach(function(el, j) {
                layoutdata.rows[i].plot_elements[j]['plotgroup'] = layoutdata.rows[i]['rowsvg'].append('g')
                    .attr("id", "plotgroup-" + layoutdata.rows[i].plot_elements[j]['parameters'].join("-"));

                layoutdata.rows[i].plot_elements[j]['path'] = layoutdata.rows[i].plot_elements[j]['plotgroup'].append("path")
                    .attr("id", "path-" + layoutdata.rows[i].plot_elements[j]['parameters'].join("-"))
                    .style("stroke", "black")
                    .style("stroke-width", 0.5)
                    .style("fill", "none");
            });

        });
    }

    function setupZoom(layoutdata) {
        // function to call when pressing zoom buttons
        const zoom = d3.zoom()
          .extent([[0, 0], [100, 100]])
          .scaleExtent([0.1, 160])
          .on("zoom", zoomed);

        // Allow zooming by mouse/trackpad
        layoutdata['mainsvg'].call(zoom);

        function zoomed({transform}) {
            axis_transform = transform.rescaleX(layoutdata['xscale']);
            // update_images(transform);
            //imagegroup.attr("transform", transform);
            axis_transform = {'k': 1, 'x': transform.x, 'y': 50};
            layoutdata.rows.forEach(function(row, i) {
                row['xaxis_group'].call(xAxis.scale(transform.rescaleX(layoutdata['xscale'])));
            });
            loadDataProducts(layoutdata);
        }
    }

    layoutdata.zoomIn = function() {
      layoutdata['mainsvg'].transition().call(zoom.scaleBy, 2);
    }
    layoutdata.zoomOut = function() {
      layoutdata['mainsvg'].transition().call(zoom.scaleBy, 0.5);
    }

    function processDataProducts(layoutdata) {
        // Some plot elements might make use of the same database table, but use different columns from that table.
        // So for efficiency, they are collected and combined here into a master list.
        data_store_products = {}
        layoutdata.rows.forEach(function(row, i) {
            row.plot_elements.forEach(function( el, j) {
                if (!(el.dataset in data_store_products)) {
                    parameters = [el.parameters];
                    data_store_products[el.dataset] = {'server': el.server, "parameters": el.parameters}
                } else {
                    el['parameters'].forEach(function(par, i) {
                        if (!(data_store_products[el.dataset].parameters.includes(par))) {
                            data_store_products[el.dataset].parameters.push(par)
                        }
                    });
                }
            });
        });
        return(data_store_products);
    }

    function loadDataProducts(layoutdata, data_store_products) {
        for (var key in data_store_products) {
            var url = data_store_products[key].server;
            url += '/data?id=' +  key;
            url += '&parameters=' + data_store_products[key].parameters.join(',');
            url += '&time.min=' + '2021-12-01T00:00:00Z';
            url += '&time.max=' + '2022-01-01T00:00:00Z';
            url += '&include=brief_header';
            d3.csv(url).then(function(data) {
                // Loops to find which plot elements to update.
                // TODO: Implement way to store this in advance
                layoutdata.rows.forEach(function(row, i) {
                    row.plot_elements.forEach(function( el, j) {
                        if (el.dataset == key) {
                            var line = d3.line()
                                .defined(function(d) { return !isNaN(d[el.parameters[1]]); })
                                .x(function(d) { return layoutdata.xscale(new Date(d.time)); })
                                .y(function(d) { return row.yscale(d[el.parameters[1]]); });

                            layoutdata.rows[i].plot_elements[j]['path']
                                .datum(data)
                                .attr("d", line);

                        };
                    });
                });
            } );
        };
        return data_store_products;
    }

    function plotData(layoutdata, data_store_products) {
        layoutdata.rows.forEach(function(row, i) {
            row.plot_elements.forEach(function(el, j) {

                data = data_store_products[el.dataset];
                path.datum(data).attr("d", svgpathdata);

            });
        });
    }
    return layoutdata;
}


// figheight = 256;

    // Add image
    images = [
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/09/20211209_000000_512_HMIB.jpg", starttime: new Date("2021-12-09T00:00:00"), endtime: new Date("2021-12-10T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/10/20211210_000000_512_HMIB.jpg", starttime: new Date("2021-12-10T00:00:00"), endtime: new Date("2021-12-11T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/11/20211211_000000_512_HMIB.jpg", starttime: new Date("2021-12-11T00:00:00"), endtime: new Date("2021-12-12T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/12/20211212_000000_512_HMIB.jpg", starttime: new Date("2021-12-12T00:00:00"), endtime: new Date("2021-12-13T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/13/20211213_000000_512_HMIB.jpg", starttime: new Date("2021-12-13T00:00:00"), endtime: new Date("2021-12-14T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/14/20211214_000000_512_HMIB.jpg", starttime: new Date("2021-12-14T00:00:00"), endtime: new Date("2021-12-15T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/15/20211215_000000_512_HMIB.jpg", starttime: new Date("2021-12-15T00:00:00"), endtime: new Date("2021-12-16T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/16/20211216_000000_512_HMIB.jpg", starttime: new Date("2021-12-16T00:00:00"), endtime: new Date("2021-12-17T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/17/20211217_000000_512_HMIB.jpg", starttime: new Date("2021-12-17T00:00:00"), endtime: new Date("2021-12-18T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/18/20211218_000000_512_HMIB.jpg", starttime: new Date("2021-12-18T00:00:00"), endtime: new Date("2021-12-19T00:00:00")},
        {url: "https://sdo.gsfc.nasa.gov/assets/img/browse/2021/12/19/20211219_000000_512_HMIB.jpg", starttime: new Date("2021-12-19T00:00:00"), endtime: new Date("2021-12-20T00:00:00")}
    ]
    imagegroups = []
    imagegroups[0] = svg.append("g").attr("class", "first").attr("transform", "translate(0,300)");
    imagegroups[1] = svg.append("g").attr("class", "second").attr("transform", "translate(0,0)");

    draw_images = function() {
        imagegroups.forEach(function(imagegroup, i) {
            imagegroup.selectAll('.image').data(images)
            .enter()
                .append("image")
                .attr("xlink:href", function(d) {return d['url'];})
                .attr("preserveAspectRatio", function(d) { return imagegroup.attr("class")=="first" ? 'none' : 'xMinyMin meet' })
                .attr("x", function(d) {return xscale(d['starttime']);} )
                .attr("y", 0)
                .attr("width", function(d) { return imagegroup.attr("class")=="first" ? (xscale(d['endtime']) - xscale(d['starttime'])) : figheight; })
                .attr("height", figheight)
        })
    }
    draw_images();

    update_images = function(transform) {
        var newscale = transform.rescaleX(xscale);
        imagegroups.forEach(function(imagegroup, i) {
            imagegroup.selectAll('image')
                .attr("x", function(d) {
                    return newscale(d['starttime']);
                } )
                .attr("x", function(d) {return newscale(d['starttime']);} )
                .attr("y", 0)
                .attr("width", function(d) { return imagegroup.attr("class")=="first" ? (newscale(d['endtime']) - newscale(d['starttime'])) : figheight; })
                .attr("height", figheight)
        });
    }





// function mousedowned(event, [,, i]) {
// d3.select(this).transition()
//     .attr("fill", "black")
//     .attr("r", radius * 2)
//   .transition()
//     .attr("fill", d3.interpolateRainbow(i / 360))
//     .attr("r", radius);
// }

//
// //return svg.node();
//
//
</script>
